﻿namespace InfragisticsGridExample
{
    using System;
    using System.ComponentModel;
    using System.Data;

    public class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public ViewModel()
        {
            this.SetUpDataTable();
        }

        public DataTable Data
        {
            get
            {
                return this.data;
            }
            private set
            {
                this.data = value;
                this.NotifyPropertyChanged("Data");
            }
        }

        public void ChangeDataTable()
        {
            this.Data.Rows.Clear();
            this.Data.Columns.Clear();

            this.Data.Columns.Add("Date", typeof(DateTime));
            this.Data.Columns.Add("Parameter 1", typeof(Parameter));
            this.Data.Columns.Add("Parameter 2", typeof(Parameter));
            this.Data.Columns.Add("Parameter 3", typeof(Parameter));
            this.Data.Columns.Add("Parameter 4", typeof(Parameter));
            this.Data.Columns.Add("Parameter 5", typeof(Parameter));
            DataRow dr1 = this.Data.NewRow();
            DataRow dr2 = this.Data.NewRow();
            DataRow dr3 = this.Data.NewRow();
            DataRow dr4 = this.Data.NewRow();
            DataRow dr5 = this.Data.NewRow();
            dr1["Date"] = new DateTime(2013,2,1);
            dr1["Parameter 1"] = new Parameter(1, 100.0);
            dr1["Parameter 2"] = new Parameter(1, 200.0);
            dr1["Parameter 3"] = new Parameter(1, 300.0);
            dr1["Parameter 4"] = new Parameter(1, 400.0);
            dr1["Parameter 5"] = new Parameter(1, 500.0);
            dr2["Date"] = new DateTime(2013, 2, 2);
            dr2["Parameter 1"] = new Parameter(1, 100.0);
            dr2["Parameter 2"] = new Parameter(1, 200.0);
            dr2["Parameter 3"] = new Parameter(1, 300.0);
            dr2["Parameter 4"] = new Parameter(1, 400.0);
            dr2["Parameter 5"] = new Parameter(1, 500.0);
            dr3["Date"] = new DateTime(2013, 2, 3);
            dr3["Parameter 1"] = new Parameter(1, 100.0);
            dr3["Parameter 2"] = new Parameter(1, 200.0);
            dr3["Parameter 3"] = new Parameter(1, 300.0);
            dr3["Parameter 4"] = new Parameter(1, 400.0);
            dr3["Parameter 5"] = new Parameter(1, 500.0);
            dr4["Date"] = new DateTime(2013, 2, 4);
            dr4["Parameter 1"] = new Parameter(1, 100.0);
            dr4["Parameter 2"] = new Parameter(1, 200.0);
            dr4["Parameter 3"] = new Parameter(1, 300.0);
            dr4["Parameter 4"] = new Parameter(1, 400.0);
            dr4["Parameter 5"] = new Parameter(1, 500.0);
            dr5["Date"] = new DateTime(2013, 2, 5);
            dr5["Parameter 1"] = new Parameter(1, 100.0);
            dr5["Parameter 2"] = new Parameter(1, 200.0);
            dr5["Parameter 3"] = new Parameter(1, 300.0);
            dr5["Parameter 4"] = new Parameter(1, 400.0);
            dr5["Parameter 5"] = new Parameter(1, 500.0);

            this.Data.Rows.Add(dr1);
            this.Data.Rows.Add(dr2);
            this.Data.Rows.Add(dr3);
            this.Data.Rows.Add(dr4);
            this.Data.Rows.Add(dr5);
        }

        private DataTable data;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void SetUpDataTable()
        {
            this.Data = new DataTable();

            this.Data.Columns.Add("Date", typeof(DateTime));
            this.Data.Columns.Add("Parameter 1", typeof(Parameter));
            this.Data.Columns.Add("Parameter 2", typeof(Parameter));
            this.Data.Columns.Add("Parameter 3", typeof(Parameter));
            this.Data.Columns.Add("Parameter 4", typeof(Parameter));
            this.Data.Columns.Add("Parameter 5", typeof(Parameter));
            this.Data.Columns.Add("Parameter 6", typeof(Parameter));
            this.Data.Columns.Add("Parameter 7", typeof(Parameter));
            this.Data.Columns.Add("Parameter 8", typeof(Parameter));
            DataRow dr1 = this.Data.NewRow();
            DataRow dr2 = this.Data.NewRow();
            DataRow dr3 = this.Data.NewRow();
            DataRow dr4 = this.Data.NewRow();
            DataRow dr5 = this.Data.NewRow();
            DataRow dr6 = this.Data.NewRow();
            DataRow dr7 = this.Data.NewRow();
            DataRow dr8 = this.Data.NewRow();
            dr1["Date"] = new DateTime(2013, 2, 1);
            dr1["Parameter 1"] = new Parameter(1, 100.0);
            dr1["Parameter 2"] = new Parameter(1, 200.0);
            dr1["Parameter 3"] = new Parameter(1, 300.0);
            dr1["Parameter 4"] = new Parameter(1, 400.0);
            dr1["Parameter 5"] = new Parameter(1, 500.0);
            dr1["Parameter 6"] = new Parameter(1, 600.0);
            dr1["Parameter 7"] = new Parameter(1, 700.0);
            dr1["Parameter 8"] = new Parameter(1, 800.0);
            dr2["Date"] = new DateTime(2013, 2, 2);
            dr2["Parameter 1"] = new Parameter(1, 100.0);
            dr2["Parameter 2"] = new Parameter(1, 200.0);
            dr2["Parameter 3"] = new Parameter(1, 300.0);
            dr2["Parameter 4"] = new Parameter(1, 400.0);
            dr2["Parameter 5"] = new Parameter(1, 500.0);
            dr2["Parameter 6"] = new Parameter(1, 600.0);
            dr2["Parameter 7"] = new Parameter(1, 700.0);
            dr2["Parameter 8"] = new Parameter(1, 800.0);
            dr3["Date"] = new DateTime(2013, 2, 3);
            dr3["Parameter 1"] = new Parameter(1, 100.0);
            dr3["Parameter 2"] = new Parameter(1, 200.0);
            dr3["Parameter 3"] = new Parameter(1, 300.0);
            dr3["Parameter 4"] = new Parameter(1, 400.0);
            dr3["Parameter 5"] = new Parameter(1, 500.0);
            dr3["Parameter 6"] = new Parameter(1, 600.0);
            dr3["Parameter 7"] = new Parameter(1, 700.0);
            dr3["Parameter 8"] = new Parameter(1, 800.0);
            dr4["Date"] = new DateTime(2013, 2, 4);
            dr4["Parameter 1"] = new Parameter(1, 100.0);
            dr4["Parameter 2"] = new Parameter(1, 200.0);
            dr4["Parameter 3"] = new Parameter(1, 300.0);
            dr4["Parameter 4"] = new Parameter(1, 400.0);
            dr4["Parameter 5"] = new Parameter(1, 500.0);
            dr4["Parameter 6"] = new Parameter(1, 600.0);
            dr4["Parameter 7"] = new Parameter(1, 700.0);
            dr4["Parameter 8"] = new Parameter(1, 800.0);
            dr5["Date"] = new DateTime(2013, 2, 5);
            dr5["Parameter 1"] = new Parameter(1, 100.0);
            dr5["Parameter 2"] = new Parameter(1, 200.0);
            dr5["Parameter 3"] = new Parameter(1, 300.0);
            dr5["Parameter 4"] = new Parameter(1, 400.0);
            dr5["Parameter 5"] = new Parameter(1, 500.0);
            dr5["Parameter 6"] = new Parameter(1, 600.0);
            dr5["Parameter 7"] = new Parameter(1, 700.0);
            dr5["Parameter 8"] = new Parameter(1, 800.0);
            dr6["Date"] = new DateTime(2013, 2, 6);
            dr6["Parameter 1"] = new Parameter(1, 100.0);
            dr6["Parameter 2"] = new Parameter(1, 200.0);
            dr6["Parameter 3"] = new Parameter(1, 300.0);
            dr6["Parameter 4"] = new Parameter(1, 400.0);
            dr6["Parameter 5"] = new Parameter(1, 500.0);
            dr6["Parameter 6"] = new Parameter(1, 600.0);
            dr6["Parameter 7"] = new Parameter(1, 700.0);
            dr6["Parameter 8"] = new Parameter(1, 800.0);
            dr7["Date"] = new DateTime(2013, 2, 7);
            dr7["Parameter 1"] = new Parameter(1, 100.0);
            dr7["Parameter 2"] = new Parameter(1, 200.0);
            dr7["Parameter 3"] = new Parameter(1, 300.0);
            dr7["Parameter 4"] = new Parameter(1, 400.0);
            dr7["Parameter 5"] = new Parameter(1, 500.0);
            dr7["Parameter 6"] = new Parameter(1, 600.0);
            dr7["Parameter 7"] = new Parameter(1, 700.0);
            dr7["Parameter 8"] = new Parameter(1, 800.0);
            dr8["Date"] = new DateTime(2013, 2, 8);
            dr8["Parameter 1"] = new Parameter(1, 100.0);
            dr8["Parameter 2"] = new Parameter(1, 200.0);
            dr8["Parameter 3"] = new Parameter(1, 300.0);
            dr8["Parameter 4"] = new Parameter(1, 400.0);
            dr8["Parameter 5"] = new Parameter(1, 500.0);
            dr8["Parameter 6"] = new Parameter(1, 600.0);
            dr8["Parameter 7"] = new Parameter(1, 700.0);
            dr8["Parameter 8"] = new Parameter(1, 800.0);
            this.Data.Rows.Add(dr1);
            this.Data.Rows.Add(dr2);
            this.Data.Rows.Add(dr3);
            this.Data.Rows.Add(dr4);
            this.Data.Rows.Add(dr5);
            this.Data.Rows.Add(dr6);
            this.Data.Rows.Add(dr7);
            this.Data.Rows.Add(dr8);
        }
    }
}